如何检查字符串是否包含Bash中的子字符串

时间:2008-10-23 12:37:32

标签: string bash substring

我在Bash中有一个字符串:

string="My string"

如何测试它是否包含其他字符串?

if [ $string ?? 'foo' ]; then
  echo "It's there!"
fi

??是我的未知运算符。我是否使用echo和grep

if echo "$string" | grep 'foo'; then
  echo "It's there!"
fi

看起来有点笨拙。

26 个答案:

答案 0 :(得分:3011)

如果您使用双括号,也可以在案例陈述之外使用Marcus's answer (* wildcards)

string='My long string'
if [[ $string == *"My long"* ]]; then
  echo "It's there!"
fi

请注意,针字符串中的空格需要放在双引号之间,而*通配符应该在外面。

答案 1 :(得分:448)

如果您更喜欢正则表达式方法:

string='My string';

if [[ $string =~ "My" ]]
then
   echo "It's there!"
fi

答案 2 :(得分:289)

我不确定使用if语句,但你可以使用case语句获得类似的效果:

case "$string" in 
  *foo*)
    # Do stuff
    ;;
esac

答案 3 :(得分:188)

兼容的答案

由于已经有很多使用Bash特定功能的答案,因此有一种方法可以在功能较差的shell下工作,例如

[ -z "${string##*$reqsubstr*}" ]

在实践中,这可能会给出:

string='echo "My string"'
for reqsubstr in 'o "M' 'alt' 'str';do
  if [ -z "${string##*$reqsubstr*}" ] ;then
      echo "String '$string' contain substring: '$reqsubstr'."
    else
      echo "String '$string' don't contain substring: '$reqsubstr'."
    fi
  done

这是在(busybox)下测试的,结果始终是:

String 'echo "My string"' contain substring: 'o "M'.
String 'echo "My string"' don't contain substring: 'alt'.
String 'echo "My string"' contain substring: 'str'.

进入一个功能

正如@EeroAaltonen所说,这是一个相同的演示版本,在相同的shell下测试:

myfunc() {
    reqsubstr="$1"
    shift
    string="$@"
    if [ -z "${string##*$reqsubstr*}" ] ;then
        echo "String '$string' contain substring: '$reqsubstr'.";
      else
        echo "String '$string' don't contain substring: '$reqsubstr'." 
    fi
}

然后:

$ myfunc 'o "M' 'echo "My String"'
String 'echo "My String"' contain substring 'o "M'.

$ myfunc 'alt' 'echo "My String"'
String 'echo "My String"' don't contain substring 'alt'.

注意:您必须转义或双重引号和/或双引号:

$ myfunc 'o "M' echo "My String"
String 'echo My String' don't contain substring: 'o "M'.

$ myfunc 'o "M' echo \"My String\"
String 'echo "My String"' contain substring: 'o "M'.

简单功能

这是在以及下进行测试的:

stringContain() { [ -z "${2##*$1*}" ]; }

这就是所有人!

然后现在:

$ if stringContain 'o "M3' 'echo "My String"';then echo yes;else echo no;fi
no
$ if stringContain 'o "M' 'echo "My String"';then echo yes;else echo no;fi
yes

...或者如果提交的字符串可能为空,如@Sjlver指出的那样,该函数将变为:

stringContain() { [ -z "${2##*$1*}" ] && [ -z "$1" -o -n "$2" ]; }

Adrian Günter's comment建议,避免-o切换:

stringContain() { [ -z "${2##*$1*}" ] && { [ -z "$1" ] || [ -n "$2" ] ;} ; }

使用空字符串:

$ if stringContain '' ''; then echo yes; else echo no; fi
yes
$ if stringContain 'o "M' ''; then echo yes; else echo no; fi
no

答案 4 :(得分:134)

您应该记住,shell脚本不是一种语言,而是一组命令。本能地,您认为此“语言”要求您使用if[关注[[。这两个都只是返回退出状态的命令,指示成功或失败(就像所有其他命令一样)。出于这个原因,我使用grep,而不是[命令。

只是做:

if grep -q foo <<<"$string"; then
    echo "It's there"
fi

现在您正在考虑if测试其后面的命令的退出状态(以分号结尾)。为什么不重新考虑你正在测试的字符串的来源?

## Instead of this
filetype="$(file -b "$1")"
if grep -q "tar archive" <<<"$filetype"; then
#...

## Simply do this
if file -b "$1" | grep -q "tar archive"; then
#...

-q选项使grep不输出任何内容,因为我们只需要返回代码。 <<<使shell扩展下一个单词并将其用作命令的输入,这是<<这里文档的单行版本(我不确定这是标准还是基础)

答案 5 :(得分:84)

接受的答案是最好的,但由于有多种方法可以做到,这是另一种解决方案:

if [ "$string" != "${string/foo/}" ]; then
    echo "It's there!"
fi

${var/search/replace}$varsearch的第一个实例替换为replace,如果找到(它不会更改$var)。如果您尝试将foo替换为空,并且字符串已更改,则显然已找到foo

答案 6 :(得分:44)

所以这个问题有很多有用的解决方案 - 但哪个最快/使用最少的资源?

使用此框架重复测试:

/usr/bin/time bash -c 'a=two;b=onetwothree; x=100000; while [ $x -gt 0 ]; do TEST ; x=$(($x-1)); done'

每次更换TEST:

[[ $b =~ $a ]]           2.92user 0.06system 0:02.99elapsed 99%CPU

[ "${b/$a//}" = "$b" ]   3.16user 0.07system 0:03.25elapsed 99%CPU

[[ $b == *$a* ]]         1.85user 0.04system 0:01.90elapsed 99%CPU

case $b in *$a):;;esac   1.80user 0.02system 0:01.83elapsed 99%CPU

doContain $a $b          4.27user 0.11system 0:04.41elapsed 99%CPU

(doContain在F. Houri的回答中)

嘻嘻哈哈:

echo $b|grep -q $a       12.68user 30.86system 3:42.40elapsed 19%CPU !ouch!

因此简单的替代选项可以在扩展测试或案例中获胜。这个案子是便携式的。

管道输出到100000 greps是可以预料的痛苦!关于无需使用外部实用程序的旧规则是正确的。

答案 7 :(得分:26)

这也有效:

if printf -- '%s' "$haystack" | egrep -q -- "$needle"
then
  printf "Found needle in haystack"
fi

负面测试是:

if ! printf -- '%s' "$haystack" | egrep -q -- "$needle"
then
  echo "Did not find needle in haystack"
fi

我认为这种风格更经典 - 更少依赖于Bash shell的功能。

--参数是纯POSIX偏执狂,用于保护输入字符串类似于选项,例如--abc-a

注意:在紧密循环中,此代码将比使用内部Bash shell功能慢 ,因为将创建一个(或两个)单独的进程并通过管道连接。

答案 8 :(得分:16)

这个怎么样:

text="   <tag>bmnmn</tag>  "
if [[ "$text" =~ "<tag>" ]]; then
   echo "matched"
else
   echo "not matched"
fi

答案 9 :(得分:14)

Bash4 +示例。注意:当单词中包含空格等时,不使用引号会引起问题。始终在bash IMO中引用。

以下是BASH4 +的一些示例:

示例1,检查字符串中的“是”(不区分大小写):

    if [[ "${str,,}" == *"yes"* ]] ;then

示例2,在字符串中检查“是”(不区分大小写):

    if [[ "$(echo "$str" | tr '[:upper:]' '[:lower:]')" == *"yes"* ]] ;then

示例3,在字符串中检查“是”(区分大小写):

     if [[ "${str}" == *"yes"* ]] ;then

示例4,在字符串中检查“是”(区分大小写):

     if [[ "${str}" =~ "yes" ]] ;then

示例5,完全匹配(区分大小写):

     if [[ "${str}" == "yes" ]] ;then

示例6,完全匹配(不区分大小写):

     if [[ "${str,,}" == "yes" ]] ;then

示例7,完全匹配:

     if [ "$a" = "$b" ] ;then

示例8,通配符匹配.ext(不区分大小写):

     if echo "$a" | egrep -iq "\.(mp[3-4]|txt|css|jpg|png)" ; then

享受。

答案 10 :(得分:11)

保罗在他的表现比较中提到:

if echo "abcdefg" | grep -q "bcdef"; then
    echo "String contains is true."
else
    echo "String contains is not true."
fi

这与POSIX兼容,就像Marcus提供的'case'$ string“in'答案一样,但比case语句答案稍微容易阅读。另请注意,这将比使用case语句慢得多,正如Paul指出的那样,不要在循环中使用它。

答案 11 :(得分:10)

This Stack Overflow answer是唯一一个捕获空格和破折号的人:

# For null cmd arguments checking   
to_check=' -t'
space_n_dash_chars=' -'
[[ $to_check == *"$space_n_dash_chars"* ]] && echo found

答案 12 :(得分:9)

一个是:

[ $(expr $mystring : ".*${search}.*") -ne 0 ] && echo 'yes' ||  echo 'no'

答案 13 :(得分:8)

[[ $string == *foo* ]] && echo "It's there" || echo "Couldn't find"

答案 14 :(得分:5)

我喜欢sed。

substr="foo"
nonsub="$(echo "$string" | sed "s/$substr//")"
hassub=0 ; [ "$string" != "$nonsub" ] && hassub=1

编辑,逻辑:

  • 使用sed从字符串

  • 中删除子字符串的实例
  • 如果新字符串与旧字符串不同,则子字符串存在

答案 15 :(得分:5)

我的.bash_profile以及我如何使用grep 如果PATH包含我的2个bin dirs,请不要追加它们

# .bash_profile
# Get the aliases and functions
if [ -f ~/.bashrc ]; then
    . ~/.bashrc
fi

U=~/.local.bin:~/bin

if ! echo "$PATH" | grep -q "home"; then
    export PATH=$PATH:${U}   
fi

答案 16 :(得分:5)

grep -q对此非常有用。

使用awk

string="unix-bash 2389"
character="@"
printf '%s' "$string" | awk -vc="$character" '{ if (gsub(c, "")) { print "Found" } else { print "Not Found" } }'

输出:

  

未找到

string="unix-bash 2389"
character="-"
printf '%s' "$string" | awk -vc="$character" '{ if (gsub(c, "")) { print "Found" } else { print "Not Found" } }'

输出:

  

实测值

原始来源:http://unstableme.blogspot.com/2008/06/bash-search-letter-in-string-awk.html

答案 17 :(得分:4)

我发现需要经常使用这个功能,所以我在我的.bashrc中使用了一个自制的shell函数,这样我就可以根据需要随时重复使用它,并且很容易记住名字:

function stringinstring()
{
    case "$2" in 
       *"$1"*)
          return 0
       ;;
    esac   
    return 1
}

要测试$string1中是否包含$string2(例如 abc )(例如 123abcABC ),我只需要运行{{ 1}}并检查返回值,例如

stringinstring "$string1" "$string2"

答案 18 :(得分:3)

尝试oobash它是bash 4的OO风格的字符串库。它支持德语变音符号。它是用bash编写的。可以使用许多功能:-base64Decode-base64Encode-capitalize-center-charAt-concat-contains,{{1 }},-count-endsWith-equals-equalsIgnoreCase-reverse-hashCode-indexOf-isAlnum-isAlpha-isAscii-isDigit-isEmpty-isHexDigit-isLowerCase-isSpace-isPrintable,{ {1}},-isUpperCase-isVisible-lastIndexOf-length-matches-replaceAll-replaceFirst,{{1 }},-startsWith-substring-swapCase-toLowerCase-toString

查看包含示例:

-toUpperCase

oobash is available at Sourceforge.net

答案 19 :(得分:3)

确切的单词匹配:

string='My long string'
exactSearch='long'

if grep -E -q "\b${exactSearch}\b" <<<${string} >/dev/null 2>&1
  then
    echo "It's there"
  fi

答案 20 :(得分:3)

问题的分机应答这里https://stackoverflow.com/a/8811800/712666

此解决方案适用于特殊字符:

# contains(string, substring)
#
# Returns 0 if the specified string contains the specified substring,
# otherwise returns 1.
contains() {
    string="$1"
    substring="$2"

    if echo "$string" | $(type -p ggrep grep | head -1) -F -- "$substring" >/dev/null; then
        return 0    # $substring is in $string
    else
        return 1    # $substring is not in $string
    fi
}

contains "abcd" "e" || echo "abcd does not contain e"
contains "abcd" "ab" && echo "abcd contains ab"
contains "abcd" "bc" && echo "abcd contains bc"
contains "abcd" "cd" && echo "abcd contains cd"
contains "abcd" "abcd" && echo "abcd contains abcd"
contains "" "" && echo "empty string contains empty string"
contains "a" "" && echo "a contains empty string"
contains "" "a" || echo "empty string does not contain a"
contains "abcd efgh" "cd ef" && echo "abcd efgh contains cd ef"
contains "abcd efgh" " " && echo "abcd efgh contains a space"

contains "abcd [efg] hij" "[efg]" && echo "abcd [efg] hij contains [efg]"
contains "abcd [efg] hij" "[effg]" || echo "abcd [efg] hij does not contain [effg]"

contains "abcd *efg* hij" "*efg*" && echo "abcd *efg* hij contains *efg*"
contains "abcd *efg* hij" "d *efg* h" && echo "abcd *efg* hij contains d *efg* h"
contains "abcd *efg* hij" "*effg*" || echo "abcd *efg* hij does not contain *effg*"

答案 21 :(得分:3)

case $string in (*foo*)
  # Do stuff
esac

答案与https://stackoverflow.com/a/229585/11267590相同。但是样式简单,并且符合POSIX。

答案 22 :(得分:2)

我使用此功能(不包括一个依赖但很明显)。它通过了下面显示的测试。如果函数返回值&gt; 0然后找到了字符串。您可以轻松地返回1或0。

function str_instr {
   # Return position of ```str``` within ```string```.
   # >>> str_instr "str" "string"
   # str: String to search for.
   # string: String to search.
   typeset str string x
   # Behavior here is not the same in bash vs ksh unless we escape special characters.
   str="$(str_escape_special_characters "${1}")"
   string="${2}"
   x="${string%%$str*}"
   if [[ "${x}" != "${string}" ]]; then
      echo "${#x} + 1" | bc -l
   else
      echo 0
   fi
}

function test_str_instr {
   str_instr "(" "'foo@host (dev,web)'" | assert_eq 11
   str_instr ")" "'foo@host (dev,web)'" | assert_eq 19
   str_instr "[" "'foo@host [dev,web]'" | assert_eq 11
   str_instr "]" "'foo@host [dev,web]'" | assert_eq 19
   str_instr "a" "abc" | assert_eq 1
   str_instr "z" "abc" | assert_eq 0
   str_instr "Eggs" "Green Eggs And Ham" | assert_eq 7
   str_instr "a" "" | assert_eq 0
   str_instr "" "" | assert_eq 0
   str_instr " " "Green Eggs" | assert_eq 6
   str_instr " " " Green "  | assert_eq 1
}

答案 23 :(得分:1)

通用的针头干草堆示例后面是变量

# Live:
    https://air.plumelabs.com/api/v1/live/7vZ5/
# Week:
    https://air.plumelabs.com/api/v1/week/7vZ5/
# Month:
    https://air.plumelabs.com/api/v1/month/7vZ5/
# Year:
    https://air.plumelabs.com/api/v1/month/7vZ5/

答案 24 :(得分:0)

由于POSIX / Busybox问题在没有提供正确答案(恕我直言)的情况下被关闭,因此我将在此处发布答案。

最短的答案是:

[ ${_string_##*$_substring_*} ] || echo Substring found!

[ "${_string_##*$_substring_*}" ] || echo 'Substring found!'

请注意, 双哈希 必填项,带有一些shell(ash)。找不到子字符串时,以上将评估[ stringvalue ]。它没有返回错误。找到子字符串后,结果为空,并求值为[ ]。由于该字符串已完全替换(由于*),因此将抛出错误代码1。

最短的常用语法:

[ -z "${_string_##*$_substring_*}" ] && echo 'Substring found!'

[ -n "${_string_##*$_substring_*}" ] || echo 'Substring found!'

另一个:

[ "${_string_##$_substring_}" != "$_string_" ] && echo 'Substring found!'

[ "${_string_##$_substring_}" = "$_string_" ] || echo 'Substring found!'

请注意单个等号!

答案 25 :(得分:0)

msg="message"

function check {
    echo $msg | egrep [abc] 1> /dev/null

    if [ $? -ne 1 ];
    then 
        echo "found" 
    else 
        echo "not found" 
    fi
}

check

这将发现a或b或c的任何出现